#!/usr/bin/python3
# -*- coding: utf-8 -*

#Ce code est un essai de sonnette connectée réalisé par Alban TREVILLY
#Condition d'utilisation : Il est facturé 2000 euros lors de chaque utilisation :-D

import RPi.GPIO as GPIO
import time
from datetime import datetime
import os
import pygame
from pygame.locals import *

GPIO.setmode(GPIO.BCM) #Attention au choix du port ; référez-vous au site https://fr.pinout.xyz/
GPIO.setup(24, GPIO.IN, pull_up_down=GPIO.PUD_UP)

#Définition du répertoire de stockage des photos
dossier_de_travail ="/home/pi/Desktop/visiteurs"

def PrisePhoto(NomPhoto): #prendre une photo avec Raspistill 
    command = "sudo raspistill -w 800 -h 600 -o "+chemin_photo+" -q 100"
    os.system(command)

if (os.path.isdir(dossier_de_travail) == False): # si le dossier pour stocker les photos n'existe pas       
   os.mkdir(dossier_de_travail)                  # alors on crée le dossier (selon le dossier désigné auparavant)
   os.chmod(dossier_de_travail,0o777)            # et on change les droits pour pouvoir effacer des photos


while True : #boucle jusqu'a interruption
  try:
        print ("Bonjour")
        print ("Script Sonnette.py lancé ; attente boucle")
        print (" ")
        
        #on attend que le bouton soit pressé
        GPIO.wait_for_edge(24, GPIO.FALLING)
        
        #on a appuyé sur le bouton ... On lance les actions
        
        #Jouer le son de sonnette avec PyGame
        pygame.mixer.init()
        son = pygame.mixer.Sound('/home/pi/sonnette/1207.wav')
        canal = son.play()
        
        #on génère le nom de la photo avec heure_min_sec
        date_today = datetime.now()
        nom_image = date_today.strftime('%d-%m-%Y_%H-%M-%S')
        
        #on déclenche la prise de photo
        chemin_photo = ''+dossier_de_travail+'/'+nom_image+'.jpeg'
        PrisePhoto(chemin_photo) #Déclenchement de la prise de photo

        #on envoie le courriel
        os.system('echo "On vient de sonner à la porte :" | mutt -s "Photo sonnette `date +%d/%m/%y` `date +%H:%M:%S`" -a '+chemin_photo+' -- destinataire@domaine.truc')

        #on imprime des bêtise à l'écran
        print("---")
        print("OK, photo prise et courriel envoyé")
        print("Maintenant, tu dois 2000 Euros à Alban")
        print("Si, si, c'est noté ligne 5 (conditions d'utilisation)")
        print("Tu peux vérifier")
        print("HiHiHi")
        print("---")
        print(" ")

        
        if (GPIO.input(24) == 0): #si le bouton est encore enfoncé (son etat sera 0)
            print ("Oups ; le bouton  a été appuyé trop longtemps !!! Je ferme boutique ; c'est le chef (Alban) qui l'a dit !")
            break # alors on sort du while 
 

  except KeyboardInterrupt:
    print ('sortie du programme!')
    raise

GPIO.cleanup()           # reinitialisation GPIO lors d'une sortie normale


